intlib::lookupexp:=proc(f) local a,b;
begin
   if type(f)="_mult" then
      # case x^a*exp(b*x) #
      if intlib::matchassign(f,_X^_pattern(a,not has,_X)
	*exp(_pattern(b,not has,_X)*_X)) then
		return(igamma(a+1,-b*_X)/(-b)^a/b)
      # case erf(b*x)*exp(-b^2*x^2) #
      elif intlib::matchassign(f,erf(_pattern(b,not has,_X)*_X)*exp(-
	_pattern(b)^2*_X^2)) then return(PI^(1/2)/4/b*erf(b*_X)^2)
      else
         f:=subs(expand(f),exp(_X)=b);
         if not has(f,_X) then return(subs(intlib::int(f/b,b),b=exp(_X)))
         end_if
      end_if
   end_if;
   # try Gaussian integrals #
   a:=intlib::gaussian(f,_X);
   if not has(a,FAIL) then simplify(a) else FAIL end_if
end_proc:

intlib::gaussian:= loadproc(intlib::gaussian,pathname("INTLIB"),"gaussian"):

